#ifndef SNAPDISPLAY_H
#define SNAPDISPLAY_H
/*
-----------------------------------------------------------------------------
 Class: SnapDisplay

 Desc: Graphics on ends of receptors on Edit screen that show the current snap type.

 Copyright (c) 2001-2002 by the person(s) listed below.  All rights reserved.
	Chris Danford
-----------------------------------------------------------------------------
*/

#include "ActorFrame.h"
#include "NoteTypes.h"
#include "Sprite.h"
#include "PlayerNumber.h"



class SnapDisplay : public ActorFrame
{
public:
	SnapDisplay();
	
	void Load( PlayerNumber pn );

	bool PrevSnapMode();
	bool NextSnapMode();

	NoteType GetNoteType() const { return m_NoteType; };

protected:
	int m_iNumCols;

	void SnapModeChanged();

	NoteType	m_NoteType;		// snap to this note type
	Sprite		m_sprIndicators[2];	// left and right side
};


#endif
